// gauss.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 4.1.2 Dvodimenzionalna polja
// Rjeavanje sustava jednadbi Gaussovim postupkom

#include <iostream>
#include <fstream>
using namespace std;

int main() {
	const int nmax = 20;
	float a[nmax][nmax+1];
	ifstream ulazniTok("koefic.dat");

	if (!ulazniTok) {
		cerr << "Ne mogu otvoriti datoteku!" << endl;
		return 1;
	}
	int n;
	ulazniTok >> n;
	if (n >= nmax) {
		cerr << "Sustav jednadbi prevelik!" << endl;
		return 2;
	}
	// uitavanje koeficijenata
	int r, s;
	for (r = 0; r < n; r++)				// po recima
		for (int s = 0; s <= n; s++)		// po stupcima
			ulazniTok >> a[r][s];
	// svoenje na trokutastu matricu
	for (r = 0; r < n; r++) {
		for (s = r + 1; s <= n; s++)
			a[r][s] /= a[r][r];
		for (int rr = r + 1; rr < n; rr++)
			for (int ss = r + 1; ss <= n; ss++)
				a[rr][ss] -= a[rr][r] * a[r][ss];
	}
	// ...te povratna supstitucija
	for (r = n - 1; r >= 0; r--)
		for (s = n - 1; s > r; s--)
			a[r][n] -= a[r][s] * a[s][n];
	// ispis rezultata
	for (r = 0; r < n; r++)
		cout << "x" << (r + 1) << " = " 
		     << a[r][n] << endl;

	char z;
	cin >> z;
	return 0;
}
