// lagrange.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 3.1.1 Jednodimenzionalna polja
// Rauna vrijednost funkcije u nekoj toki pomou Lagrangeovog polinoma

#include <iostream>
#include <fstream>
using namespace std;

int main() {
	const int nmax = 100;
	float x[nmax], y[nmax];
	ifstream ulazniTok("podaci.dat");

	if (!ulazniTok) {
		cerr << "Ne mogu otvoriti traenu datoteku" 
			 << endl;
		return 1;
	}
	int i = -1;
	while (!ulazniTok.eof()) {		// prekida se na kraju datoteke
		if (++i >= nmax) {
			cerr << "Previe podataka!" << endl;
			return 2;
		}
		ulazniTok >> x[i] >> y[i];
	}
	if (i < 0) {
		cerr << "Nema podataka!" << endl;
		return 3;
	}
	int n = i;
	float x0, y0 = 0.;
	cout << "Upii broj: ";
	cin >> x0;
	for (i = 0; i < n; i++) {
		float Li = 1.;
		for (int j = 0; j < n; j++) {
			if (i != j) {
				Li *= (x0 - x[j]);
				Li /= (x[i] - x[j]);
			}
		}
		y0 += (Li * y[i]);
	}
	cout << "f(" << x0 << ") = " << y0 << endl;

	char z;
	cin >> z;
	return 0;
}
