// integral.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 5.10 Pokazivai na funkcije
// Integracija trapeznim pravilom

#include <iostream>
#include <cmath>
using namespace std;

float Integral(double(*f)(double), double x0, double xn,
			   double relGrijeh = 1.e-5,
			   long CircusMaximus = 65536L);
double Podintegralna(double x);

int main() {
	cout << Integral(sin, 0, 3.14159) << endl;
	cout << Integral(Podintegralna, 0, 1.) << endl;

	char z;
	cin >> z;
	return 0;
}

float Integral(double(*f)(double), double x0, double xn,
			   double relGrijeh, long CircusMaximus) {
	long n = 1;
	double h0 = xn - x0;
	double sumaStara = 0.;
	double sumaNova = f(x0) + f(xn);
	do {
		sumaStara = sumaNova / 2.;
		sumaNova = 0.;
		n *= 2;
		for (long i = 1; i < n; i += 2)
			sumaNova += f(h0 * i / n + x0);
		sumaNova = sumaStara + sumaNova / n;
	} while((n <= CircusMaximus) && (sumaNova != 0) &&
			(fabs(1. - sumaStara / sumaNova) > relGrijeh));
	return sumaNova * h0;
}

double Podintegralna(double x) {
	return sin(x) * sin(x);
}
