// nest.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.10 Ugnijeene klase
// Sustav praenja alokacije memorije


#include <cstdlib>
#include <cstring>
#include <iostream>
using namespace std;

class MemorijskiAlokator {
private:

	// ugnijeena klasa
	class Alokacija {
	public:
		Alokacija *slijed, *pret;
		size_t velicina;
		void *pocetak;
		int linija;
		char *datoteka;

		Alokacija(size_t vel, void *pok, int lin,
				  char *dat);
		~Alokacija();
		void Ispisi();
	};

	Alokacija *prva, *zadnja;
public:
	MemorijskiAlokator() : prva(NULL), zadnja(NULL) {}
	~MemorijskiAlokator();
	void Dodaj(size_t vel, void *pok, int lin,
			   char *dat = NULL);
	int Brisi(void *pok);
	void Ispisi();
};

MemorijskiAlokator::Alokacija::Alokacija(size_t vel,
	void *pok, int lin, char *dat) :
		velicina(vel), pocetak(pok), linija(lin),
		datoteka(new char [strlen(dat) + 1]),
		slijed(NULL), pret(NULL) {
	if (dat)
		strcpy(datoteka, dat);
	else
		datoteka[0] = 0;
}

MemorijskiAlokator::Alokacija::~Alokacija() {
	delete [] datoteka;
}

void MemorijskiAlokator::Alokacija::Ispisi() {
	cout << datoteka << ":" << linija << "  " << velicina;
	cout << "  " << pocetak << endl;
}

MemorijskiAlokator::~MemorijskiAlokator() {
	Alokacija *priv = prva, *priv1;
	while (priv) {
		priv1 = priv;
		priv = priv->slijed;
		delete priv1;
	}
}

void MemorijskiAlokator::Dodaj(size_t vel, void *pok,
							  int lin, char *dat) {
	Alokacija *alo = new Alokacija(vel, pok, lin, dat);
	alo->pret = zadnja;
	alo->slijed = NULL;
	if (zadnja)
		zadnja->slijed = alo;
	else
		prva = alo;
	zadnja = alo;
}

int MemorijskiAlokator::Brisi(void *pok) {
	Alokacija *priv = prva;
	while (priv) {
		if (priv->pocetak == pok) {
			if (priv->slijed)
				priv->slijed->pret = priv->pret;
			else
				zadnja = priv->pret;
			if (priv->pret)
				priv->pret->slijed = priv->slijed;
			else
				prva = priv->slijed;
			return 1;
		}
		priv = priv->pret;
	}
	return 0;
}

void MemorijskiAlokator::Ispisi() {
	Alokacija *priv = prva;
	while (priv) {
		priv->Ispisi();
		priv = priv->slijed;
	}
}
