// odrezi.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.12.1 Pokazivai na podatkovne lanove
// Rezanje linije

#include <iostream>
using namespace std;

class Linija {
private:
	int X1, Y1, X2, Y2;
	void OdreziTocku(int Linija::*pok1,
					 int Linija::*pok2,
					 int v1, int v2, int p, int tip);

public:
	Linija (int x1, int y1, int x2, int y2) : X1(x1), Y1(y1), X2(x2), Y2(y2) {};
	int DajX1() { return X1; }
	int DajY1() { return Y1; }
	int DajX2() { return X2; }
	int DajY2() { return Y2; }
	void Odrezi(int px1, int py1, int px2, int py2);
};

void Linija::Odrezi(int px1, int py1, int px2, int py2) {
	OdreziTocku(&Linija::X1, &Linija::Y1,
				X2 - X1, Y2 - Y1, px1, 1);
	OdreziTocku(&Linija::X1, &Linija::Y1,
				X2 - X1, Y2 - Y1, px2, 0);
	OdreziTocku(&Linija::Y1, &Linija::X1,
				Y2 - Y1, X2 - X1, py1, 1);
	OdreziTocku(&Linija::Y1, &Linija::X1,
				Y2 - Y1, X2 - X1, py2, 0);
	OdreziTocku(&Linija::X2, &Linija::Y2,
				X1 - X2, Y1 - Y2, px1, 1);
	OdreziTocku(&Linija::X2, &Linija::Y2,
				X1 - X2, Y1 - Y2, px2, 0);
	OdreziTocku(&Linija::Y2, &Linija::X2,
				Y1 - Y2, X1 - X2, py1, 1);
	OdreziTocku(&Linija::Y2, &Linija::X2,
				Y1 - Y2, X1 - X2, py2, 0);
}

void Linija::OdreziTocku(int Linija::*pok1,
						 int Linija::*pok2,
						 int v1, int v2, int p, int tip) {
	if ((this->*pok1 < p && tip) || 
		(this->*pok1 > p && !tip)) {
		float param = (p - this->*pok1) / static_cast<float>(v1);
		if ((param > 0 && tip) || (param < 1 && !tip)) {
			this->*pok2 = this->*pok2 + static_cast<int>(param * v2 + 0.5);
			this->*pok1 = p;
		}
		else
			this->*pok1 = this->*pok2 = -1;
	}
}


int main() {
	Linija crta1(1, 1, 10, 10);
	crta1.Odrezi(2, 2, 9, 9);
	
	cout << crta1.DajX1() << "," << crta1.DajY1() << endl
		 << crta1.DajX2() << "," << crta1.DajY2() << endl;

	Linija crta2(1, 10, 10, 1);
	crta2.Odrezi(2, 2, 9, 9);
	
	cout << crta2.DajX1() << "," << crta2.DajY1() << endl
		 << crta2.DajX2() << "," << crta2.DajY2() << endl;

	char z;
	cin >> z;
	return 0;
}