// vektor1.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 6.13 Privremeni objekti
// Klasa Vektor i ispis prilikom stvaranja i unitavanja
// privremenih objekata

#include <iostream>
using namespace std;

class Vektor {
friend void ZbrojiVektore(Vektor &a, Vektor &b,
						  Vektor &rez);
private:
	static int brojac;
	int redbr;
	double ax, ay;
public:
	Vektor(double x = 0, double y = 0);
	~Vektor();
	double DajX() { return ax; }
	double DajY() { return ay; }
	void PostaviXY(double x, double y) { ax = x; ay = y; }
};

int Vektor::brojac = 0;

Vektor::Vektor(double x, double y) :
		ax(x), ay(y), redbr(++brojac) {
	cout << "Stvoren vektor pod brojem " << redbr << endl;
	cout << "X: " << ax << "    Y: " << ay << endl;
}

Vektor::~Vektor() {
	cout << "Uniten vektor pod brojem " << redbr << endl;
	cout << "X: " << ax << "    Y: " << ay << endl;
}

void ZbrojiVektore(Vektor &a, Vektor &b, Vektor &rez) {
	cout << "Zbrajam" << endl;
	rez.ax = a.ax + b.ax;
	rez.ay = a.ay + b.ay;
	cout << "Zbrojio sam" << endl;
}

int main() {
	cout << "Ulazak u main" << endl;
	Vektor c;
	cout << "Pozivam ZbrojiVektore" << endl;
	ZbrojiVektore(Vektor(10.0, 2.8), Vektor(-2.0, 5.0), c);
	cout << "Zavravam" << endl;

	char z;
	cin >> z;
	return 0;
}