// alokacija.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.3.6. Operatori new i delete


#include <cstddef>
#include <cstring>
#include <iostream>
using namespace std;

struct Alokacija {
	Alokacija *sljeceda;
	void *mjesto;
	int linija;
	size_t velicina;
	char datoteka[80];
};

Alokacija *Prva = NULL, *Zadnja = NULL;

void DodajAlokaciju(int lin, size_t vel, char *dat,
					void *mj) {
	Alokacija *pom = (Alokacija*)malloc(sizeof(Alokacija));
	pom->sljeceda = NULL;
	pom->linija = lin;
	pom->velicina = vel;
	pom->mjesto = mj;
	if (dat)
		strcpy(pom->datoteka, dat);
	else
		pom->datoteka[0] = 0;
	if (Zadnja)
		Zadnja->sljeceda = pom;
	else
		Prva = pom;
	Zadnja = pom;
}

void UkloniAlokaciju(void *mj) {
	Alokacija *pom = Prva, *pom1 = NULL;
	while (pom) {
		if (pom->mjesto == mj) {
			if (pom1)
				pom1->sljeceda = pom->sljeceda;
			else
				Prva = pom->sljeceda;
			if (!pom->sljeceda) Zadnja = pom1;
			free(pom);
			break;
		}
		pom1 = pom;
		pom = pom->sljeceda;
	}
}

void *operator new(size_t vel, int lin, char *dat) {
	void *alo = malloc(vel);
	DodajAlokaciju(lin, vel, dat, alo);
	return alo;
}

void *operator new[](size_t vel, int lin, char *dat) {
	void *alo = malloc(vel);
	DodajAlokaciju(lin, vel, dat, alo);
	return alo;
}

void operator delete(void *mjesto) {
	UkloniAlokaciju(mjesto);
}

void operator delete[](void *mjesto) {
	UkloniAlokaciju(mjesto);
}

void IspisiListu() {
	Alokacija *pom = Prva;
	while (pom) {
		cout << pom->linija << ":";
		cout << pom->datoteka << ":";
		cout << pom->velicina << endl;
		pom = pom->sljeceda;
	}
}


int main() {
	char *p = new (__LINE__, __FILE__) char[20];
	Vektor *v = new (__LINE__, __FILE__) Vektor(4.0, 9.0);
	// radi neki posao
	delete [] p;
	delete v;
	// provjeri ima li alokacija koje nisu osloboene
	IspisiListu();
	return 0;
}
