// razlucivanjekonverzije3.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.1.3. Operatori konverzije

#include <iostream>
#include <cstring>
using namespace std;

class Identifikator;		// deklaracija unaprijed

class ZnakovniNiz {
private:
	char *pokNiz;

public:
	ZnakovniNiz(char *niz = "");
	ZnakovniNiz(const Identifikator &ref);
	operator char*() { return pokNiz; };

};


ZnakovniNiz::ZnakovniNiz(char *niz) : pokNiz(new char[strlen(niz) + 1]) {
	strcpy(pokNiz, niz);
}


class Identifikator {
private:
	int indeks;
	ZnakovniNiz naziv;

public:
	Identifikator(int ind, const ZnakovniNiz &ref) :
		indeks(ind), naziv(ref) { }

	const ZnakovniNiz &DajNiz() const { return naziv; }
	operator ZnakovniNiz() { return naziv; }
};


ZnakovniNiz:: ZnakovniNiz(const Identifikator &ref) :
	pokNiz(new char[strlen(ref.DajNiz().pokNiz)]) {
	strcmp(pokNiz, ref.DajNiz().pokNiz);
}


void NekaFunkcija(ZnakovniNiz);

int main() {
	Identifikator a(5, ZnakovniNiz("znn"));
	NekaFunkcija(a);	// pogreka: nije jasno koju konverziju koristiti
//	treba koristiti donji poziv:
//	NekaFunkcija(a.operator ZnakovniNiz());
	return 0;
}
