// vektor.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 8.2. Osnove preoptereenja operatora
// zbrajanje vektora

#include <iostream>
using namespace std;

class Vektor {
	friend Vektor operator+(Vektor &a, Vektor &b);
private:
	float ax, ay;
public:
	Vektor(float x = 0, float y = 0) { ax = x; ay = y; }
	void PostaviXY(float x, float y) { ax = x; ay = y; }
	float DajX() const { return ax; }
	float DajY() const { return ay; }
	void MnoziSkalarom(float skalar);
};

inline void Vektor::MnoziSkalarom(float skalar) {
	ax *= skalar;
	ay *= skalar;
}

Vektor operator+(Vektor &a, Vektor &b) {
	return Vektor(a.ax + b.ax, a.ay + b.ay);
}


int main() {
	Vektor a(12.0, 3.0), b(-3.0, -6.0), c;
	c = a + b;	// poziva se operator za zbrajanje vektora
	cout << c.DajX() << "    " << c.DajY() << endl;
	return 0;
}
