//  vlista.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 9.2. Specifikacija nasljeivanja

// Vezana lista

#include <cstdlib>
#include <iostream>
using namespace std;


class Atom {
private:
	Atom *pokSljedeci, *pokPrethodni;
public:
	Atom *Sljedeci() { return pokSljedeci; }
	Atom *Prethodni() { return pokPrethodni; }
	void StaviSljedeci(Atom *pok) { pokSljedeci = pok; }
	void StaviPrethodni(Atom *pok) { pokPrethodni = pok; }
};


class LVektor : public Atom {
private:
	float ax, ay;
public:
	LVektor(float a = 0, float b = 0) : ax(a), ay(b) {}
	void PostaviXY(float x, float y) { ax = x; ay = y; }
	float DajX() { return ax; }
	float DajY() { return ay; }
};


class Lista {
private:
	Atom *glava, *rep;
public:
	Lista() : glava(NULL), rep(NULL) {}
	Atom *AmoGlavu() { return glava; }
	Atom *AmoRep() { return rep; }
	void UgurajClan(Atom *pok, Atom *izaKojeg = NULL);
	void GoniClan(Atom *pok);
};

void Lista::UgurajClan(Atom *pok, Atom *izaKojeg) {
	// da li se dodaje na poetak?
	if (izaKojeg != NULL) {
		// ne dodaje se na poetak

		// da li se dodaje na kraj?
		if (izaKojeg->Sljedeci() != NULL)
			// ne dodaje se na kraj
			izaKojeg->Sljedeci()->StaviPrethodni(pok);
		else
			// dodaje se na kraj
			rep = pok;
		pok->StaviSljedeci(izaKojeg->Sljedeci());
		izaKojeg->StaviSljedeci(pok);
	}
	else {
		// dodaje se na poetak
		pok->StaviSljedeci(glava);
		if (glava != NULL)
			// da li ve ima lanova u listi?
			glava->StaviPrethodni(pok);
		glava = pok;
	}
	pok->StaviPrethodni(izaKojeg);
}

void Lista::GoniClan(Atom *pok) {
	if (pok->Sljedeci() != NULL)
		pok->Sljedeci()->StaviPrethodni(pok->Prethodni());
	else
		rep = pok->Prethodni();
	if (pok->Prethodni() != NULL)
		pok->Prethodni()->StaviSljedeci(pok->Sljedeci());
	else
		glava = pok->Sljedeci();
}

int main() {
	Lista lst;

	// punjenje liste
	lst.UgurajClan(new LVektor(10.0, 20.0));
	lst.UgurajClan(new LVektor(-5.0, -6.0));
	// ...

	// itanje liste
	LVektor *pok = static_cast<LVektor *>(lst.AmoGlavu());
	while (pok) {
		// obrada vektora, na primjer ispis:
		cout << "(" << pok->DajX() << ","
			 << pok->DajY() << ")" << endl;
		pok = static_cast<LVektor *>(pok->Sljedeci());
	}
	return 0;
}
