//  complex.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 10.6: Razred complex


#include <iostream>
#include <complex>
using namespace std;


int main() {

	complex<double> z1(3.0, 4.0);
	complex<float> z2(1.0, 2.0);

	// ispiimo ih:
	cout << "z1: " << z1 << endl;
	cout << "z2: " << z2 << endl;

	// ispiimo ih u polarnim koordinatama:
	cout << "z1: modul: " << abs(z1) << endl
		 << "    faza: " << arg(z1) << endl;
	cout << "z2: modul: " << abs(z2) << endl
		 << "    faza: " << arg(z2) << endl;

	// budui da su operator+ i operator* te funkcija pow() definirani samo za
	// argumente istog tipa, moramo krirati privremene objekte
	cout << "zbroj z1 + z2: " << z1 + complex<double>(z2.real(), z2.imag()) << endl;
	cout << "umnoak z1 * z2: " << z1 * complex<double>(z2.real(), z2.imag()) << endl;
	cout << "potencija z1^z2: " << pow(z1, complex<double>(z2.real(), z2.imag())) << endl;


	complex<float> z5(polar(5.0, 0.9273));
	cout << z5 << endl;

	complex<int> zkk1(1, 1);
	cout << conj(zkk1) << endl;

	char z;
	cin >> z;
	return 0;
}

