//  lista.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 10.3.1. Definicija predloka klase

#include <cstring>

template <class Tip>
class ElementListe {
private:
	Tip vrij;
	ElementListe *prethodni, *sljedeci;
public:
	ElementListe *Prethodni() { return prethodni; }
	ElementListe *Sljedeci() { return sljedeci; }
	void PostaviPrethodni(ElementListe *pret) { prethodni = pret; }
	void PostaviSljedeci(ElementListe *sljed) { sljedeci = sljed; }
	ElementListe(const Tip &elem);
	ElementListe() {}
	Tip &DajVrijednost();
};


template <class Tip>
inline ElementListe<Tip>::ElementListe(const Tip &elem) :
	vrij(elem), prethodni(NULL), sljedeci(NULL) {}


template <class Tip>
inline Tip &ElementListe<Tip>::DajVrijednost() {
	return vrij;
}


// specijalizacija za char *

class ElementListe<char *> {
private:
	char *vrij;
	ElementListe *sljedeci, *prethodni;
public:
	ElementListe(char *elem);
	~ElementListe();
	char *DajVrijednost() { return vrij; }
	void Kopiraj(char *buff); 
};

ElementListe<char *>::~ElementListe() {
	delete [] vrij;
}



void ElementListe<char *>::Kopiraj(char *buff) {	strcpy(buff, vrij);
}

ElementListe<char *>::ElementListe(char *elem) :
			vrij(new char[strlen(elem) + 1]),
			sljedeci(NULL), prethodni(NULL) {
	strcpy(vrij, elem);
}
