//  lista.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 10.5: Realizacija klase Lista predlokom


#include <iostream>
using namespace std;

template <class Tip>
class Lista {
private:

	class ElementListe {
	private:
		Tip vrij;
		ElementListe *prethodni, *sljedeci;
	public:
		ElementListe *Prethodni() { return prethodni; }
		ElementListe *Sljedeci() { return sljedeci; }
		void StaviPrethodni(ElementListe *pret)
				{ prethodni = pret; }
		void StaviSljedeci(ElementListe *sljed)
				{ sljedeci = sljed; }
		ElementListe(const Tip &elem) : prethodni(NULL),
										sljedeci(NULL),
										vrij(elem) {}
		Tip &DajVrijednost() { return vrij; }
	};

	ElementListe *glava, *rep;
	int duljina;
public:
	Lista() : glava(NULL), rep(NULL), duljina(0) {}
	ElementListe *AmoGlavu() { return glava; }
	ElementListe *AmoRep() { return rep; }
	void UgurajClan(Tip pok, int redBr = 0);
	void GoniClan(int koga);
	Tip &operator [](int ind);
	int KolikoSiDuga() { return duljina; }
};

template <class Tip>
void Lista<Tip>::UgurajClan(Tip pok, int redBr) {
	if (redBr > duljina)		// indeks izvan dozvoljenog
		redBr = duljina;		// dodaj na kraj
	ElementListe *elt = new ElementListe(pok);
	ElementListe *izaKojeg = NULL;
	if (redBr) {
		izaKojeg = glava;
		redBr--;
		while (redBr) {
			izaKojeg = izaKojeg->Sljedeci();
			redBr--;
		}
	}
	// da li se dodaje na poetak?
	if (izaKojeg != NULL) {
		// ne dodaje se na poetak.
		// da li se dodaje na kraj?
		if (izaKojeg->Sljedeci() != NULL)
			// ne dodaje se na kraj
			izaKojeg->Sljedeci()->StaviPrethodni(elt);
		else
			// dodaje se na kraj
			rep = elt;
		elt->StaviSljedeci(izaKojeg->Sljedeci());
		izaKojeg->StaviSljedeci(elt);
	}
	else {
		// dodaje se na poetak
		elt->StaviSljedeci(glava);
		if (glava != NULL)
			// da li ve ima lanova u listi?
			glava->StaviPrethodni(elt);
		glava = elt;
	}
	elt->StaviPrethodni(izaKojeg);
	duljina++;
}

template <class Tip>
void Lista<Tip>::GoniClan(int koga) {
	if (koga > duljina)			// indeks izvan postojeeg
		return;
	ElementListe *pok = glava;
	while (koga) {
		pok = pok->Sljedeci();
		koga--;
	}
	if (pok->Sljedeci() != NULL)
		pok->Sljedeci()->StaviPrethodni(pok->Prethodni());
	else
		rep = pok->Prethodni();
	if (pok->Prethodni() != NULL)
		pok->Prethodni()->StaviSljedeci(pok->Sljedeci());
	else
		glava = pok->Sljedeci();
	delete pok;
	duljina--;
}

template <class Tip>
Tip &Lista<Tip>::operator [](int ind) {
	ElementListe *pok = glava;
	while (ind > 0) {
		pok = pok->Sljedeci();
		ind--;
	}
	return pok->DajVrijednost();
}



int main() {

	Lista<int> intLista;

	cout << "duljina: " << intLista.KolikoSiDuga() << endl;

	intLista.UgurajClan(5, 8);
	intLista.UgurajClan(4, 0);
	intLista.UgurajClan(3, 8);

	cout << "duljina: " << intLista.KolikoSiDuga() << endl;

	int i;
	for (i = 0; i < intLista.KolikoSiDuga(); i++)
		cout << intLista[i] << endl;

	intLista.GoniClan(2);

	cout << "duljina: " << intLista.KolikoSiDuga() << endl;

	for (i = 0; i < intLista.KolikoSiDuga(); i++)
		cout << intLista[i] << endl;
	
	char z;
	cin >> z;
	return 0;
}