//  listastatic.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 10.3.5. Predloci klasa sa statikim lanovima

#include <iostream>
using namespace std;


template <class Tip>
class ElementListe {
private:
	Tip vrij;
	ElementListe *prethodni, *sljedeci;
public:
	ElementListe *Prethodni() { return prethodni; }
	ElementListe *Sljedeci() { return sljedeci; }
	void PostaviPrethodni(ElementListe *pret) { prethodni = pret; }
	void PostaviSljedeci(ElementListe *sljed) { sljedeci = sljed; }
	ElementListe(const Tip &elem);
	ElementListe() {}
	Tip &DajVrijednost();
};



template <class T>
class Lista {
private:
	ElementListe<T> *glava, *rep;
public:
	static int brojLista;

	Lista();
	~Lista();
	void Dodaj(T *elt);
	void Brisi(T *elt);
	ElementListe<T> *Pocetak() { return glava; }
	ElementListe<T> *Kraj() { return rep; }
};

template <class T>
Lista<T>::Lista() : glava(NULL), rep(NULL) {
	brojLista++;
}

template <class T>
Lista<T>::~Lista() {
	brojLista--;
}

template <class T>
int Lista<T>::brojLista = 0;


int main() {
	Lista<int> lista1, lista2;
	Lista<char *> lista3;
	cout << "Broj cjelobrojnih lista: " <<
		Lista<int>::brojLista << endl;
	cout << "Broj lista znakovnih nizova: " <<
		Lista<char *>::brojLista << endl;

	char z;
	cin >> z;
	return 0;
}
