//  obracunaj.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.3: Tijek obrade iznimke

#include <iostream>
#include <string>
using namespace std;


class NizoveIznimke {
private:
	string pogreska;
public:
	NizoveIznimke(const char *np) : pogreska(np) { }
	NizoveIznimke(NizoveIznimke &ref) : pogreska(ref.pogreska) { }
	string Pogreska() { return pogreska; }
};


class Niz {
private:
	int duljina;
	int *pokNiz;
public:
	Niz(int d) : duljina(d), pokNiz(new int[d]) {}
	int& operator[] (int indeks);
};

inline int& Niz::operator[] (int indeks) {
	if (indeks < 0 || indeks >= duljina)
		throw NizoveIznimke("Pogrean pristup nizu.");
	return pokNiz[indeks];
}

void Obracunaj(Niz &n) {
	int u;
	u = n[10];		// mogua pogreka ako niz n ima
					// manje od deset lanova
	u += n[3];		// i ovo je diskutabilno mjesto
}

void Poziv(int anum, int bnum) {
	Niz b(bnum);
	try {
		Niz a(anum);
		cout << "Obraunavam se s poljem \'a\'" << endl;
		Obracunaj(a);
		cout << "Obraunavam se s poljem \'b\'" << endl;
		Obracunaj(b);
	}
	catch (NizoveIznimke& pogr) {
		cerr << pogr.Pogreska() << endl;
	}
	cout << "Kraj Poziva(" << anum << ", " << bnum << ")!" << endl;
}


int main() {
	Poziv(11, 6);
	Poziv(6, 5);

	char z;
	cin >> z;
	return 0;
}