//  znakovniniz.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 12.5: Obrada pogreaka konstruktora

#include <iostream>
using namespace std;


class ZnakovniNiz {
friend ZnakovniNiz operator +(ZnakovniNiz &a, ZnakovniNiz &b);
private:
	char *pokNiz;
public:
	ZnakovniNiz(char *niz = "");
	ZnakovniNiz(const ZnakovniNiz &ref);
	~ZnakovniNiz();

	operator const char *() { return pokNiz; }
	ZnakovniNiz &operator =(const ZnakovniNiz &ref);
};


ZnakovniNiz::ZnakovniNiz(char *niz) :
				pokNiz(new char[strlen(niz) + 1]) {
	if (pokNiz == NULL) throw "Nema dovoljno memorije.";
	strcpy(pokNiz,niz);
}


ZnakovniNiz::ZnakovniNiz(const ZnakovniNiz &ref) :
				pokNiz(new char[strlen(ref.pokNiz) + 1]) {
	if (pokNiz == NULL) throw "Nema dovoljno memorije.";
	strcpy(pokNiz, ref.pokNiz);
}


ZnakovniNiz::~ZnakovniNiz() {
	delete [] pokNiz;
}


ZnakovniNiz &ZnakovniNiz::operator =(const ZnakovniNiz &ref) {
	if (this != &ref) {
		delete [] pokNiz;
		pokNiz = new char[strlen(ref.pokNiz) + 1];
		strcpy(pokNiz, ref.pokNiz);
	}
	return *this;
}


ZnakovniNiz operator +(ZnakovniNiz &a, ZnakovniNiz &b) {
	char *pok = new char[strlen(a.pokNiz) +
						 strlen(b.pokNiz) +1];
	strcpy(pok, a.pokNiz);
	strcat(pok, b.pokNiz);
	ZnakovniNiz rez(pok);
	delete [] pok;
	return rez;
}


int main() {
	try {
		ZnakovniNiz ime("Salvador ");
		ZnakovniNiz prezime("Dal");
		ZnakovniNiz slikar;
		slikar = ime + prezime;
		cout << (const char *)slikar << endl;
	}
	catch (const char *pogr) {
		cout << pogr << endl;
		char z;
		cin >> z;
		return 1;
	}
	char z;
	cin >> z;
	return 0;
}
