//  typeid.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 13.2: Operator typeid

#include <iostream>
#include <typeinfo>
using namespace std;

class Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju" << endl; }
	// ...
};

class LinijaSaStrelicama : public Linija {
// ...
public:
	virtual void Crtaj() { cout << "Crtam Liniju sa strelicama" << endl; }
	// ...
};


int main() {

	int cijeli = 5;
	if (typeid(cijeli) == typeid(int))
		cout << "'cijeli' je tipa int" << endl;

	if (typeid(5) == typeid(int))
		cout << "'5' je tipa int" << endl;

	Linija lnSaStoga;
	if (typeid(lnSaStoga) == typeid(Linija))
		cout << "'lnSaStoga' je tipa Linija" << endl;

	LinijaSaStrelicama *lns1 = new LinijaSaStrelicama;
	if (typeid(lns1) == typeid(LinijaSaStrelicama*))
		cout << "Ja sam linija sa S" << endl;

	Linija *lns2 = new LinijaSaStrelicama;
	if (typeid(lns2) == typeid(Linija*))
		cout << "lns2: Ja sam samo linija" << endl;
	if (typeid(lns2) == typeid(LinijaSaStrelicama*))
		cout << "lns2: Ja sam linija sa S" << endl;

	if (typeid(*lns2) == typeid(Linija))
		cout << "*lns2: Ja sam samo linija" << endl;
	if (typeid(*lns2) == typeid(LinijaSaStrelicama))
		cout << "*lns2: Ja sam linija sa S" << endl;

	Linija &lnsRef = *lns2;
	if (typeid(lnsRef) == typeid(LinijaSaStrelicama))  // tono
		cout << "lnsRef: Ja sam linija sa S" << endl;
	if (typeid(lnsRef) == typeid(Linija))			 // netono
		cout << "lnsRef: Ja sam samo linija" << endl;

	if (typeid(&lnsRef) == typeid(LinijaSaStrelicama*))  // ne
		cout << "&lnsRef: Ja sam linija sa S" << endl;
	if (typeid(&lnsRef) == typeid(Linija*))			   // tono
		cout << "&lnsRef: Ja sam samo linija" << endl;

	delete lns1;
	delete lns2;

	Linija ln1;
	const Linija ln2;

	if (typeid(ln1) == typeid(ln2))				// uvijek je istina
		cout << "const ln2 == ne-const ln1" << endl;

	if (typeid(ln1) == typeid(const Linija))	// takoer je
											// uvijek istina
		cout << "const ln1 == const Linija" << endl;

											
	char z;
	cin >> z;
	return 0;
}
