#include <iostream>
using namespace std;
#include "tocka.h"
#include "pravac.h"
#include "kruznica.h"
#include "presjek.h"

static void PozoviPaIspisi(const Kruznica &k,
						   const Pravac &p) {
	Tocka t_pr1;			// toke za pohranjivanje
	Tocka t_pr2;			// koordinata presjecita
	switch (PresjecistaKruzniceIPravca(k, p, t_pr1, t_pr2)) {
	  case 0:
		cout << "Nema presjecista!" << endl;
		break;
	  case 1:
		cout << "Pravac dira kruznicu u tocki T("
			 << t_pr1.x() << "," << t_pr1.y() << ")";
		break;
	  case 2:
		cout << "Pravac sijece kruznicu u tockama T1("
			 << t_pr1.x() << "," << t_pr1.y() << ") i T2("
			 << t_pr2.x() << "," << t_pr2.y() << ")" << endl;
		break;
	}
}

int main() {
	Tocka t0(1., 1.);		// postavljamo toku
	double r = 5.;			// polumjer krunice
	Kruznica k(t0, r);		// definiramo krunicu
	Pravac p(t0, 1., 1.);	// pravac kroz sredite krunice
							// pod 45 stupnjeva
	PozoviPaIspisi(k, p);

	char z;
	cin >> z;
	return 0;
}
