#include <cmath>

#include "presjek.h"

VrstaPresjeka PresjecistaKruzniceIPravca(const Kruznica &k,
					const Pravac &p, Tocka &t1, Tocka &t2) {
	if (p.kb() != 0.) {		// ako pravac nije okomit
		double a_b = p.ka() / p.kb();
		double c_b = p.kc() / p.kb();
		double A = 1. + a_b * a_b;
		double B = 2. * (a_b * c_b + a_b * k.y0() - k.x0());
		double C = k.x0() * k.x0() + k.y0() * k.y0() -
				   k.r() * k.r() + c_b * (c_b + 2 * k.y0());
		double diskr = B * B - 4 * A * C;
		if (diskr < 0)		// nema presjecista
		  return NijednoPresjeciste;
		else if (diskr == 0) {		// pravac dira kruznicu
			double x1 = -B / 2. / A;
			double y1 = -a_b * x1 - c_b;
			t1.pomakni(x1, y1);		// obje tocke jednake
			t2.pomakni(x1, y1);
			return PravacDiraKruznicu;
		}
		double x1 = (-B + sqrt(diskr)) / 2. / A;
		double y1 = -a_b * x1 - c_b;
		t1.pomakni(x1, y1);
		x1 = (-B - sqrt(diskr)) / 2. / A;
		y1 = -a_b * x1 - c_b;
		t2.pomakni(x1, y1);
		return DvaPresjecista;
	}
	else {
		// kd za vertikalni pravac ete,
		// naravno, napisati sami!
	}
}
