//  binarno.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 15.7.5. Binarni zapis i uitavanje

#include <iostream>
#include <fstream>
#include <cstring>
#include <string>
using namespace std;

int main() {

    typedef long streampos;
	streampos pozSljed = 0;
	fstream bazaImena("imenabin.dat", ios_base::in |
					  ios_base::binary);
	if (!bazaImena) {
		bazaImena.clear();
		bazaImena.open("imenabin.dat", ios_base::out |
					   ios_base::binary);
		bazaImena.write((char *) &pozSljed, sizeof(streampos));
	}
	bazaImena.close();
	bazaImena.open("imenabin.dat", ios_base::in | ios_base::out |
					ios_base::binary);
	if (bazaImena.fail()) {
		cout << "Nisam uspio kreirati datoteku!" << endl;
		char z;
		cin >> z;
		return 1;
	}

	string novoIme;
	getline(cin, novoIme);
	// ponavlja unos novih imena sve dok je duljina utipkanog
	// imena razliita od nule
	while (novoIme.length() > 0) {
		streampos pozPreth = 0;
		streampos pozTemp = 0;
		// na poetak datoteke
		bazaImena.seekg(0);
		// uita poziciju sljedeeg
		bazaImena.read((char *) &pozSljed, sizeof(streampos));
		if (bazaImena.fail()) {
			cout << "Nisam uspio proitati podatak!" << endl;
			bazaImena.clear();
			break;
		}
		// prolazi datoteku sve dok postoji sljedei
		while (pozSljed) {
			// pomakne na sljedei zapis
			bazaImena.seekg(pozSljed);
			string imeNaDisku;
			// uita pokaziva na sljedei zapis
			bazaImena.read((char *) &pozTemp, sizeof(streampos));
			// uita ime u tekuem zapisu
			getline(bazaImena, imeNaDisku);
			if (strcoll(imeNaDisku.c_str(), novoIme.c_str()) >= 1)
				break;		// ako novo treba doi ispred, prekida
			pozPreth = pozSljed;
			pozSljed = pozTemp;
		}
		// prvo dopisuje novo ime na kraj datoteke
		bazaImena.seekg(0, ios_base::end);
		pozTemp = bazaImena.tellg();
		bazaImena.write((char *) &pozSljed, sizeof(streampos));
		bazaImena.write(novoIme.c_str(), novoIme.length() + 1);
		if (bazaImena.fail()) {
			cout << "Nisam uspio upisati podatak!" << endl;
			break;
		}
		// postavlja se na prethodni zapis u nizu i usmjerava ga
		// na novododani zapis
		bazaImena.seekp(pozPreth);
		bazaImena.write((char *) &pozTemp, sizeof(streampos));
		// unos novog imena
		getline(cin, novoIme);
	}
	cout << "Upisi su zavreni." << endl << endl;
	// slijedi kd za ispis liste...

	cout << "Dosad upisana imena:" << endl;
	bazaImena.seekg(0);
	bazaImena.read((char *) &pozSljed, sizeof(streampos));
	while (pozSljed) {
		bazaImena.seekg(pozSljed);
		bazaImena.read((char *) &pozSljed, sizeof(streampos));
		getline(bazaImena, novoIme, '\0');
		cout << novoIme << endl;
	}
	cout << "*** Konac popisa ***" << endl;

	char z;
	cin >> z;
	return 0;
}