//  fstream.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 15.7.3. Razred fstream

#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;

int main() {

	float staroStanje = 0;
	fstream strujiStruja("MojaTuga.dat", ios_base::in);
	if (!strujiStruja) {
		cerr << "Ne postoji datoteka \"MojaTuga.dat\"" << endl
			 << "Bit e stvorena nova." << endl;
		strujiStruja.clear();
		strujiStruja.open("MojaTuga.dat", ios_base::out);
		strujiStruja << staroStanje << endl;
	}
	strujiStruja.close();
	strujiStruja.open("MojaTuga.dat", ios_base::in | ios_base::out);
	do {
		strujiStruja >> staroStanje;
	} while(!strujiStruja.eof());

	cout << setiosflags(ios_base::fixed) << setprecision(2)
		 << setw(15) << "staro stanje:"
		 << setw(8) << staroStanje  << endl;

	cout << setw(15) << "uplate:";
	float uplate;
	cin >> uplate;

	cout << setw(15) << "rashodi:";
	double rashodi;		// za rashode uvijek koristite double!
	cin >> rashodi;
	// ispisuje 25 znakova '-' za podcrtavanje
	cout << setw(25) << setfill('-') << " " << endl
		 << setfill(' ');
	float novoStanje = staroStanje + uplate - rashodi;
	strujiStruja.clear();
	strujiStruja << novoStanje << endl;
	if (strujiStruja.fail())
		cerr << "Nekaj ne valja s upisom" << endl;
	else {
		cout << setw(15) << "novo stanje:"
			 << setw(8) << novoStanje << endl << endl
			 << "Novo stanje je s uspjehom pohranjeno" << endl;
	}

	char z;
	cin >> z;
	return 0;
}