//  peek.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 1.5.4: Ostali lanovi razreda istream

#include <iostream>
#include <locale>
#include <string>
using namespace std;

int main() {

	char znak;
	locale loc("");
	locale::global(loc);
	
	cout << "Napii niz brojeva. Slovo prekida niz." << endl;

	while ((znak = cin.peek()) != '\n') {
		// preskae praznine:
		if (isspace(znak)) cin.get(znak);
		// je li prvi znak niza znamenka, predznak ili dec. toka?
		else if (isdigit(znak) || znak == '+' || znak == '-' || 
				 znak == '.') {
			int predznak = (znak == '-') ? -1 : +1;
			// izluuje predznak s toka
			if (znak == '-' || znak == '+') cin >> znak;
			if (!(isdigit(znak = cin.peek()) || znak == '.')) {
				cout << "Pogreka: iza predznaka mora biti "
						"broj!" << endl;
				break;
			}
			if (cin.peek() == '.') {
				// izluuje decimalnu toku da bi provjerio
				// slijedi li iza nje znamenka
				cin >> znak;
				if (!isdigit(cin.peek())) {
					cout << "Pogreka: iza toke mora biti "
							"broj!" << endl;
					break;
				}
				// ako je OK, vraa decimalnu toku na tok
				cin.putback(znak);
			}
			double broj;
			cin >> broj;
			cout << (broj * predznak) << endl;
			if (!isspace(cin.peek())) {
				cout << "Pogreka: iza broja mora biti razmak!"
					 << endl;
				break;
			}
		}
		// ako je prvi znak niza slovo ili podcrtavanje:
		else if (isalpha(znak) || znak == '_') {
//			int i = 0;
			// izluuje pojedinano znakove sve dok je slovo,
			// broj ili podcrtavanje
			string rijec;
			do {
				rijec += cin.get();
			} while(isalnum(znak = cin.peek()) || znak == '_');
//			rijec[i] = '\0';
			cout << rijec << endl;
			if (!isspace(cin.peek())) {
				cout << "Pogreka: iza rijei mora biti razmak!"
					 << endl;
				break;
			}
		}
		// sve ostalo "guta":
		else
			cin >> znak;
	}

	cout << "***GOTOVO***" << endl;
	char z;
	cin >> z;
	return 0;
}
