//  bitset.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Skup bitova


#include <iostream>
#include <bitset>
#include <limits>
using namespace std;


int main() {

	enum { namakanje, pretpranje, pranje, ispiranje, centrifugiranje, brojCiklusa };
	bitset<brojCiklusa> perilica;

	// ukljuimo pranje i centrifugiranje:
	perilica.set(pranje);
	perilica.set(centrifugiranje);

	cout << "Aktivirana su " << perilica.count() << " ciklusa." << endl;
	cout << "Ispis bitova: " << perilica << endl;

	if (perilica.any()) {
		for (int bit = 0; bit < perilica.size(); bit++) {
			if (perilica[bit]) 
				cout << bit+1 << ". ciklus je ukljuen." << endl;
		}
	}

	// iskljuimo sve cikluse:
	perilica.reset();


	int n = 12345;
	cout << bitset<numeric_limits<int>::digits> (n) << endl;

	string broj("10101");
	cout << broj << " kao broj: " << bitset<20> (broj).to_ulong() << endl;

	char z;
	cin >> z;
	return 0;
}

