//  multiset.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <set>
#include <string>
#include <locale>
using namespace std;


class CroManji {
public:
	bool operator() (const string &x, const string &y) const;
};

bool CroManji::operator() (const string &x, const string &y) const {
	if (strcoll(x.c_str(), y.c_str()) < 0)
		return true;
	return false;
}


int main() {

	locale::locale("");

	multiset<string, CroManji> filmskiNaslovi;
	filmskiNaslovi.insert("Tko pjeva zlo ne misli");
	filmskiNaslovi.insert("Selo moje malo");
	filmskiNaslovi.insert("Diskretni arm buroazije");
	filmskiNaslovi.insert("Maak Fritz");
	filmskiNaslovi.insert("Arsen i stare ipke");
	filmskiNaslovi.insert("Tko to tamo pjeva");
	filmskiNaslovi.insert("M.A.S.H.");
	filmskiNaslovi.insert("ivot Briana");

	filmskiNaslovi.insert("Selo moje malo");

	multiset<string, CroManji>::iterator prvi = filmskiNaslovi.begin();
	multiset<string, CroManji>::iterator zadnji = filmskiNaslovi.end();

	cout << "Evidencija:" << endl;

	while (prvi != zadnji) {
		cout << *prvi++ << endl;
	}

	cout << "Rjeimo se Sela:" << endl;
/*	filmskiNaslovi.erase("Selo moje malo");
	prvi = filmskiNaslovi.begin();
	// istrijebili smo sva "Sela ...":
	while (prvi != zadnji)
		cout << *prvi++ << endl;
*/

	multiset<string, CroManji>::iterator zaEgzekuciju = filmskiNaslovi.find("Selo moje malo");
	filmskiNaslovi.erase(zaEgzekuciju);
	prvi = filmskiNaslovi.begin();
	while (prvi != zadnji)
		cout << *prvi++ << endl;

	char z;
	cin >> z;
	return 0;
}

