//  ptr_fun.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Funkcijski objekti - Adapteri


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <functional>
using namespace std;


class videoFil {
	string ime;
	string prezime;
	int clanskiBroj;
	string posudjeniNaslov;
public:
	videoFil(const string &i, const string &p, const int clBr, const string naslov) :
		ime(i), prezime(p), clanskiBroj(clBr), posudjeniNaslov(naslov) {}
	void IspisiNaslov();
	string DajIme() const { return ime; }
	string DajPrezime() const { return prezime; }
};


void videoFil::IspisiNaslov() {
	cout << posudjeniNaslov << endl;
	return;
}


bool JesiLTaj(const videoFil vf, const string ip) {
	return ip == (vf.DajIme() + " " + vf.DajPrezime());
}


int main() {

	vector<videoFil> filmoljupci;
	filmoljupci.push_back(videoFil("Franjo", "Tuman", 1, "Obitelj Adams"));
	filmoljupci.push_back(videoFil("Anto", "Bakovi", 4, "Sve to ste htjeli znati o seksu a niste se usudili pitati"));
	filmoljupci.push_back(videoFil("Vladimir", "eks", 2, "Tequilla Sunrise"));
	filmoljupci.push_back(videoFil("Miroslav", "Kutle", 3, "3:10 za Yumu"));
	filmoljupci.push_back(videoFil("Anto", "Bakovi", 4, "Emanuelle"));
	filmoljupci.push_back(videoFil("Paali", "Ivi", 4, "Trei ovjek"));


	// vektor pokazivaa na objekte tipa videoFil
	vector<videoFil*> sumnjivac;
	vector<videoFil>::iterator nasao = filmoljupci.begin();
	vector<videoFil>::iterator kraj = filmoljupci.end();

	// pokazivae na sve koji zadovoljavaju uvjet pohrani u novi vektor
	string imePrezime("Anto Bakovi");
	while ((nasao = find_if(nasao, kraj, bind2nd(ptr_fun(JesiLTaj), imePrezime))) != kraj) 
		sumnjivac.push_back(nasao++);

	vector<videoFil*>::iterator prvi = sumnjivac.begin();
	vector<videoFil*>::iterator zadnji = sumnjivac.end();

	cout << imePrezime << " ima posueno:" << endl;

	for_each(prvi, zadnji, mem_fun(&videoFil::IspisiNaslov));

	char z;
	cin >> z;
	return 0;
}

