//  set3.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Asocijativni spremnici


#include <iostream>
#include <set>
#include <locale>
using namespace std;


template <class Tip>
class ProizvoljniSort {
public:
	enum modSortiranja {odNajmanjeg, odNajveceg};
private:
	modSortiranja mod;

public:
	// konstruktor
	ProizvoljniSort(modSortiranja m = odNajmanjeg) : mod(m) {}
	// operator ()
	bool operator() (const Tip &x, const Tip &y) const {
		return mod == odNajmanjeg ? x < y : y < x;
	}
};


typedef set<int, ProizvoljniSort<int> > CjelobrojniSet;

int main() {

//	set<int, ProizvoljniSort<int> > cijeliBrojeviPrviPuta;
	CjelobrojniSet cijeliBrojeviPrviPuta;
	cijeliBrojeviPrviPuta.insert(12);
	cijeliBrojeviPrviPuta.insert(7);
	cijeliBrojeviPrviPuta.insert(3);
	cijeliBrojeviPrviPuta.insert(5);
	cijeliBrojeviPrviPuta.insert(4);

//	set<int, ProizvoljniSort<int> >::iterator prvi = cijeliBrojeviPrviPuta.begin();
//	set<int, ProizvoljniSort<int> >::iterator zadnji = cijeliBrojeviPrviPuta.end();
	CjelobrojniSet::iterator prvi = cijeliBrojeviPrviPuta.begin();
	CjelobrojniSet::iterator zadnji = cijeliBrojeviPrviPuta.end();

	cout << "Skup cijelih brojeva od najmanjeg:" << endl;

	while (prvi != zadnji) 
		cout << *prvi++ << endl;

	
	ProizvoljniSort<int> odNajvecegPremaNajmanjem(ProizvoljniSort<int>::odNajveceg);

//	set<int, ProizvoljniSort<int> > cijeliBrojeviDrugiPuta(odNajvecegPremaNajmanjem);
	CjelobrojniSet cijeliBrojeviDrugiPuta(odNajvecegPremaNajmanjem);
	cijeliBrojeviDrugiPuta.insert(12);
	cijeliBrojeviDrugiPuta.insert(7);
	cijeliBrojeviDrugiPuta.insert(3);
	cijeliBrojeviDrugiPuta.insert(5);
	cijeliBrojeviDrugiPuta.insert(4);

	prvi = cijeliBrojeviDrugiPuta.begin();
	zadnji = cijeliBrojeviDrugiPuta.end();

	cout << "Skup cijelih brojeva od najveeg:" << endl;

	while (prvi != zadnji) 
		cout << *prvi++ << endl;

	char z;
	cin >> z;
	return 0;
}

