//  vector.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz poglavlja 16.3.1. Spremnici


#include <vector>
#include <string>
#include <iostream>
using namespace std;

int main() {

	vector<string> sveMojeLjubavi;

	cout << "Moj trenutni kapacitet je: " << sveMojeLjubavi.capacity() << endl;

	sveMojeLjubavi.push_back(string("The Beatles"));
	sveMojeLjubavi.push_back(string("Tangerine Dream"));
	sveMojeLjubavi.push_back(string("Talking Heads"));

	cout << "Vektor ima " << sveMojeLjubavi.size() 
		 << " lanova, a moe trenutno primiti "
		 << sveMojeLjubavi.capacity() << " lanova" << endl;

	cout << "max_size = " << sveMojeLjubavi.max_size() << endl;

	sveMojeLjubavi.push_back(string("The Cure"));
	sveMojeLjubavi.push_back(string("Nick Cave & Bad Seeds"));

	cout << "Vektor sada ima " << sveMojeLjubavi.size() 
		 << " lanova, a moe trenutno primiti "
		 << sveMojeLjubavi.capacity() << " lanova" << endl;

	// ispiimo ih:
	for (int i = 0; i < sveMojeLjubavi.size(); i++) 
		cout << sveMojeLjubavi[i] << endl;


	sveMojeLjubavi.reserve(100);

	cout << "max_size = " << sveMojeLjubavi.max_size() << endl;

	string prvaLjubav = sveMojeLjubavi.front();
	string zadnjaLjubav = sveMojeLjubavi.back();

	cout << "Moja prva ljubav: " << prvaLjubav << endl;
	cout << "Zadnja ljubav: " << zadnjaLjubav << endl;


	cout << "Iznenada mi je kapacitet narastao na: " << sveMojeLjubavi.capacity() << endl;


	sveMojeLjubavi.clear();
	cout << (sveMojeLjubavi.empty() ? "Nema vie ljubavi!" :	"to je to jo ostalo od nae ljubavi!") << endl;

	cout << "tip vrijednosti: " << typeid(vector<string>::value_type).name() << endl;
	cout << "veliina elementa: " << typeid(vector<string>::size_type).name() << endl;


	vector<int> cijeli(2, 10);

	cout << "tip vrijednosti: " << typeid(vector<int>::value_type).name() << endl;
	cout << "veliina elementa: " << typeid(vector<int>::size_type).name() << endl;

	vector<int> cijeli_novi(1, 10);
	cijeli.swap(cijeli_novi);
	for (int i = 0; i < cijeli_novi.size(); i++) 
		cout << cijeli_novi[i] << endl;

	vector<int> kvadrati(4);
	kvadrati[0] = 1;
	kvadrati[1] = 4;
	kvadrati[2] = 9;
	kvadrati[3] = 16;

	vector<int>::iterator prvi = kvadrati.begin();
	vector<int>::iterator zadnji = kvadrati.end();

	while (prvi != zadnji)
		cout << *prvi++ << endl;

	vector<int> duplich(kvadrati.begin()+1, kvadrati.end()-1);

	prvi = duplich.begin();
	zadnji = duplich.end();

	while (prvi != zadnji)
		cout << *prvi++ << endl;


	vector<int> v(4, 1);

	prvi = v.begin();
	cout << *prvi << endl;				// ispisat e 1

	v.insert(v.begin(), 2);				// umeemo 2 na poetak
	cout << *prvi << endl;				// opaaa!?
	prvi = v.begin();
	cout << *prvi << endl;				// sada je ve bolje!
	
	char z;
	cin >> z;
	return 0;
}
