//  veznici.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Funkcijski objekti - Veznici


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <functional>
using namespace std;

template<class T>
class veci : public unary_function<T, bool> {
	T arg2;
public:
	explicit veci(const T &x) : arg2(x) {}
	bool operator()(const T &x) const { return x > arg2; }
};



int main() {


	vector<int> brojevi;
	brojevi.push_back(23);
	brojevi.push_back(3);
	brojevi.push_back(45);
	brojevi.push_back(27);
	brojevi.push_back(5);

	vector<int>::iterator prvi = brojevi.begin();
	vector<int>::iterator zadnji = brojevi.end();

	vector<int>::iterator nasao = find_if(prvi, zadnji, veci<int>(24));

	if (nasao != zadnji)
		cout << "Naao sam: " << *nasao << endl;
	else
		cout << "Nema takvog lana u popisu!" << endl;
	

	prvi = brojevi.begin();
	zadnji = brojevi.end();
	nasao = find_if(prvi, zadnji, bind2nd(greater<int>(), 24));

	if (nasao != zadnji)
		cout << "Naao sam: " << *nasao << endl;
	else
		cout << "Nema takvog lana u popisu!" << endl;

	char z;
	cin >> z;
	return 0;
}

