//  videofil.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Poglavlja 16: Algoritmi i funkcijski objekti - Predikati


#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <functional>
using namespace std;

class videoFil {
	string ime;
	string prezime;
	unsigned int clanskiBroj;
	string posudjeniNaslov;
public:
	videoFil(const string &i, const string &p, const int clBr, const string naslov) :
		ime(i), prezime(p), clanskiBroj(clBr), posudjeniNaslov(naslov) {}
	string DajIme() const { return ime; }
	string DajPrezime() const { return prezime; }
	unsigned int DajClanskiBroj() const { return clanskiBroj; }
	string DajNaslov() const { return posudjeniNaslov; }
};


class jesiLiTaj : public unary_function<videoFil, bool> {
	string ime;
	string prezime;
public:
	explicit jesiLiTaj(const string& i, const string& p) :
		ime(i), prezime(p) { }
	bool operator() (const videoFil& vf) const 
	   { return (ime == vf.DajIme() && prezime == vf.DajPrezime()); }
};


int main() {


	vector<videoFil> filmoljupci;
	filmoljupci.push_back(videoFil("Franjo", "Tuman", 1, "Obitelj Adams"));
	filmoljupci.push_back(videoFil("Anto", "Bakovi", 4, "Sve to ste htjeli znati o seksu a niste se usudili pitati"));
	filmoljupci.push_back(videoFil("Vladimir", "eks", 2, "Jo jednu mi natoi rundu"));
	filmoljupci.push_back(videoFil("Miroslav", "Kutle", 3, "3:10 za Yumu"));
	filmoljupci.push_back(videoFil("Anto", "Bakovi", 4, "Emanuelle"));


	vector<videoFil>::iterator prvi = filmoljupci.begin();
	vector<videoFil>::iterator zadnji = filmoljupci.end();

	cout << "Evidencija:" << endl;

	while (prvi != zadnji) {
		cout << (*prvi).DajPrezime() << ", " << (*prvi).DajIme() << "\t" << (*prvi).DajNaslov() << endl;
		prvi++;
	}

	prvi = filmoljupci.begin();

	vector<videoFil>::iterator nasao = find_if(prvi, zadnji, jesiLiTaj("Anto", "Bakovi"));

	if (nasao != filmoljupci.end())
		if ((*nasao).DajNaslov().length() != 0)
			cout << "Ima posueno: " << (*nasao).DajNaslov() << endl;
		else
			cout << "Nema posueno nita!" << endl;
	else
		cout << "Nema takvog lana u popisu!" << endl;
	

	// kako mozemo nai vie njih koji zadovoljavaju uvjet:
	nasao = filmoljupci.begin();
	vector<videoFil> sumnjiviFilmoljupci;

	while ((nasao = find_if(nasao, zadnji, jesiLiTaj("Anto", "Bakovi"))) != filmoljupci.end()) 
		sumnjiviFilmoljupci.push_back(*nasao++);

	prvi = sumnjiviFilmoljupci.begin();
	zadnji = sumnjiviFilmoljupci.end();

	while (prvi != zadnji) {
		cout << (*prvi).DajNaslov() << endl;
		prvi++;
	}

	char z;
	cin >> z;
	return 0;
}

