//  adjacent_difference.cpp

// "Demistificirani C++", Boris Motik & Julijan ribar
// Primjer iz Priloga C: Generiki algoritmi

#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
using namespace std;


template<class T>
class umnozak : public binary_function<T, T, T> {
public:
    T operator()(const T& x, const T& y) const { return x * y; }
};


int main() {
	int ia[] = {1, 3, 5, 7, 14, 20};
	vector<int> v(ia, ia+6);
	vector<int> rezultat(6);

	adjacent_difference(v.begin(), v.end(), rezultat.begin());

	vector<int>::iterator first = rezultat.begin();
	vector<int>::iterator last = rezultat.end();

	// ispisuje: 1, 2, 2, 2, 7, 6
	while (last != first)
		cout << *first++ << endl;

	adjacent_difference(v.begin(), v.end(), rezultat.begin(), umnozak<float>());
	
	first = rezultat.begin();

	// ispisuje: 1, 3, 15, 35, 98, 280
	while (last != first)
		cout << *first++ << endl;

	char z;
	cin >> z;
	return 0;
}